#include <allegro.h>      /* Allegro rules!!! */
#include <string.h>
#include <stdio.h>
#include "edop.h"
#include "ymw.h"
#include "FileIO.h"
#include "mem.h"
#include "gfxhelp.h"
#include "ColorPicker.h"
#include "MobileDialog.h"
#include "ObjectDialog.h"
#include "ShopDialog.h"
#include "genproc.h"

#include "find.h"
#include "lists.h"

char *shop_lister( int index, int *list_size );
int shop_list_proc( int msg, DIALOG *d, int c );
char *item_lister( int index, int *list_size );
int item_list_proc( int msg, DIALOG *d, int c );
char *room_lister( int index, int *list_size );
int room_list_proc( int msg, DIALOG *d, int c );
int d_shop_map_proc( int msg, DIALOG *d, int c );
int shp_ed_refresher( int msg, DIALOG *d, int c );
char *shop_bv_lister( int index, int *list_size );
int shop_bv_list_proc( int msg, DIALOG *d, int c );
char *withwho_bv_lister( int index, int *list_size );
int withwho_bv_list_proc( int msg, DIALOG *d, int c );
char *bspec_lister( int index, int *list_size );
int bspec_list_proc( int msg, DIALOG *d, int c );
int d_aupd_edit_proc( int msg, DIALOG *d, int c );
char *temper_lister( int index, int *list_size );
int temper_list_proc( int msg, DIALOG *d, int c );

MENU menu_shop_list[]=
{
   /* text,             proc,           child,      flags, dp */
    { "&Create new",    NULL,           NULL,       0,     NULL },
    { "&Edit",          NULL,           NULL,       0,     NULL },
    { "Edit &source",   NULL,           NULL,       0,     NULL },
    { "&Delete",        NULL,           NULL,       0,     NULL },
    { NULL,             NULL,           NULL,       0,     NULL }
};

MENU menu_item_list[]=
{
   /* text,             proc,           child,      flags, dp */
    { "&Add",           NULL,           NULL,       0,     NULL },
    { "&Edit source",   NULL,           NULL,       0,     NULL },
    { "&Delete",        NULL,           NULL,       0,     NULL },
    { NULL,             NULL,           NULL,       0,     NULL }
};

MENU menu_room_list[]=
{
   /* text,             proc,           child,      flags, dp */
    { "&Add",           NULL,           NULL,       0,     NULL },
    { "&Delete",        NULL,           NULL,       0,     NULL },
    { NULL,             NULL,           NULL,       0,     NULL }
};

MENU menu_bspec_list[]=
{
   /* text,             proc,           child,      flags, dp */
    { "&Add",           NULL,           NULL,       0,     NULL },
    { "&Delete",        NULL,           NULL,       0,     NULL },
    { NULL,             NULL,           NULL,       0,     NULL }
};

MENU object_type_list_menu[] = {
/*00*/{ "Light",            NULL,           NULL,       0,     NULL },
/*01*/{ "Scroll",           NULL,           NULL,       0,     NULL },
/*02*/{ "Wand",             NULL,           NULL,       0,     NULL },
/*03*/{ "Staff",            NULL,           NULL,       0,     NULL },
/*04*/{ "Weapon",           NULL,           NULL,       0,     NULL },
/*05*/{ "-Fireweapon",      NULL,           NULL,       0,     NULL },
/*06*/{ "-Missile",         NULL,           NULL,       0,     NULL },
/*07*/{ "Treasure",         NULL,           NULL,       0,     NULL },
/*08*/{ "Armor",            NULL,           NULL,       0,     NULL },
/*09*/{ "Potion",           NULL,           NULL,       0,     NULL },
/*10*/{ "-Worn",            NULL,           NULL,       0,     NULL },
/*11*/{ "Other",            NULL,           NULL,       0,     NULL },
/*12*/{ "Trash",            NULL,           NULL,       0,     NULL },
/*13*/{ "-Trap",            NULL,           NULL,       0,     NULL },
/*14*/{ "Container",        NULL,           NULL,       0,     NULL },
/*15*/{ "Note",             NULL,           NULL,       0,     NULL },
/*16*/{ "Drink Container",  NULL,           NULL,       0,     NULL },
/*17*/{ "Key",              NULL,           NULL,       0,     NULL },
/*18*/{ "Food",             NULL,           NULL,       0,     NULL },
/*19*/{ "Money",            NULL,           NULL,       0,     NULL },
/*20*/{ "Pen",              NULL,           NULL,       0,     NULL },
/*21*/{ "Boat",             NULL,           NULL,       0,     NULL },
/*22*/{ "Fountain",         NULL,           NULL,       0,     NULL },
      { NULL,               NULL,           NULL,       0,     NULL }
};

DIALOG shp_ed_dlg[]=
{
     /* proc,                    x,   y,   w,   h,   fg,  bg,  key, flags,  d1,         d2, dp,                           dp2,      dp3 */
/*00*/{ shp_ed_refresher,        0,   0,   0,   0,   0,   0,   0,   0,      0,          0,  NULL,                         NULL,     NULL },
/*01*/{ d_shadow_box_proc,       0,   0,   540, 440, CTX, CFG, 0,   0,      0,          0,  NULL,                         NULL,     NULL },
/*02*/{ d_ctext_proc,            131, 5,   0,   8,   CTX, CFG, 0,   0,      0,          0,  "Shops",                      NULL,     NULL },
/*03*/{ shop_list_proc,          5,   14,  262, 62,  CTX, CFG, 0,   0,      0,          0,  shop_lister,                  NULL,     NULL },
/*04*/{ d_ctext_proc,            398, 5,   0,   8,   CTX, CFG, 0,   0,      0,          0,  "Items",                      NULL,     NULL },
/*05*/{ item_list_proc,          272, 14,  262, 62,  CTX, CFG, 0,   0,      0,          0,  item_lister,                  NULL,     NULL },
/*06*/{ d_ctext_proc,            167, 80,  0,   8,   CTX, CFG, 0,   0,      0,          0,  "Shop Rooms",                 NULL,     NULL },
/*07*/{ room_list_proc,          5,   89,  325, 62,  CTX, CFG, 0,   0,      0,          0,  room_lister,                  NULL,     NULL },
/*08*/{ d_shop_map_proc,         335, 89,  195, 160, CTX, CFG, 0,   0,      0,          0,  NULL,                         NULL,     NULL },
/*09*/{ shop_bv_list_proc,       5,   154, 157, 62,  CTX, CFG, 0,   0,      0,          0,  shop_bv_lister,               NULL,     NULL },
/*10*/{ withwho_bv_list_proc,    167, 154, 157, 62,  CTX, CFG, 0,   0,      0,          0,  withwho_bv_lister,            NULL,     NULL },
/*11*/{ d_text_proc,             5,   220, 88,  8,   CTX, CFG, 0,   0,      0,          0,  "Hours (1):",                 NULL,     NULL },
/*12*/{ d_num_edit_proc,         88,  220, 24,  8,   CTX, CBD, 0,   0,      2,          0,  "ho1",                        NULL,     NULL },
/*13*/{ d_text_proc,             116, 220, 8,   8,   CTX, CFG, 0,   0,      0,          0,  "-",                          NULL,     NULL },
/*14*/{ d_num_edit_proc,         128, 220, 24,  8,   CTX, CBD, 0,   0,      2,          0,  "hc1",                        NULL,     NULL },
/*15*/{ d_text_proc,             5,   229, 88,  8,   CTX, CFG, 0,   0,      0,          0,  "Hours (2):",                 NULL,     NULL },
/*16*/{ d_num_edit_proc,         88,  229, 24,  8,   CTX, CBD, 0,   0,      2,          0,  "ho2",                        NULL,     NULL },
/*17*/{ d_text_proc,             116, 229, 8,   8,   CTX, CFG, 0,   0,      0,          0,  "-",                          NULL,     NULL },
/*18*/{ d_num_edit_proc,         128, 229, 24,  8,   CTX, CBD, 0,   0,      2,          0,  "hc2",                        NULL,     NULL },
/*19*/{ temper_list_proc,        5,   390, 262, 44,  CTX, CFG, 0,   0,      0,          0,  temper_lister,                NULL,     NULL },
/*20*/{ d_ctext_proc,            270, 256, 0,   8,   CTX, CFG, 0,   0,      0,          0,  "Message When...",            NULL,     NULL },
/*21*/{ d_text_proc,             5,   265, 208, 8,   CTX, CFG, 0,   0,      0,          0,  "Shop doesn't have item:",    NULL,     NULL },
/*22*/{ d_edit_proc,             213, 265, 322, 8,   CTX, CBD, 0,   0,      NAMESIZE,   0,  blankstr,                     NULL,     NULL },
/*23*/{ d_text_proc,             5,   274, 208, 8,   CTX, CFG, 0,   0,      0,          0,  "Player doesn't have item:",  NULL,     NULL },
/*24*/{ d_edit_proc,             213, 274, 322, 8,   CTX, CBD, 0,   0,      NAMESIZE,   0,  blankstr,                     NULL,     NULL },
/*25*/{ d_text_proc,             5,   283, 208, 8,   CTX, CFG, 0,   0,      0,          0,  "Shop won't buy:",            NULL,     NULL },
/*26*/{ d_edit_proc,             213, 283, 322, 8,   CTX, CBD, 0,   0,      NAMESIZE,   0,  blankstr,                     NULL,     NULL },
/*27*/{ d_text_proc,             5,   292, 208, 8,   CTX, CFG, 0,   0,      0,          0,  "Shop's short on cash:",      NULL,     NULL },
/*28*/{ d_edit_proc,             213, 292, 322, 8,   CTX, CBD, 0,   0,      NAMESIZE,   0,  blankstr,                     NULL,     NULL },
/*29*/{ d_text_proc,             5,   301, 208, 8,   CTX, CFG, 0,   0,      0,          0,  "Player's short on cash:",    NULL,     NULL },
/*30*/{ d_edit_proc,             213, 301, 322, 8,   CTX, CBD, 0,   0,      NAMESIZE,   0,  blankstr,                     NULL,     NULL },
/*31*/{ d_text_proc,             5,   310, 208, 8,   CTX, CFG, 0,   0,      0,          0,  "Bought Successfully:",       NULL,     NULL },
/*32*/{ d_edit_proc,             213, 310, 322, 8,   CTX, CBD, 0,   0,      NAMESIZE,   0,  blankstr,                     NULL,     NULL },
/*33*/{ d_text_proc,             5,   319, 208, 8,   CTX, CFG, 0,   0,      0,          0,  "Sold Successfully:",         NULL,     NULL },
/*34*/{ d_edit_proc,             213, 319, 322, 8,   CTX, CBD, 0,   0,      NAMESIZE,   0,  blankstr,                     NULL,     NULL },
/*35*/{ d_ctext_proc,            270, 328, 0,   8,   CTX, CFG, 0,   0,      0,          0,  "Item name lists",            NULL,     NULL },
/*36*/{ bspec_list_proc,         5,   337, 530, 36,  CTX, CFG, 0,   0,      0,          0,  bspec_lister,                 NULL,     NULL },
/*37*/{ d_menubutton_proc,       5,   375, 124, 12,  CTX, CFG, 0,   D_EXIT, 0,          0,  "Light",         object_type_list_menu, NULL },
/*38*/{ d_aupd_edit_proc,        145, 377, 390, 8,   CTX, CBD, 0,   0,      NAMESIZE,   0,  blankstr,                     NULL,     NULL },
/*39*/{ d_text_proc,             167, 220, 112, 8,   CTX, CFG, 0,   0,      0,          0,  "Sell Profit:",               NULL,     NULL },
/*40*/{ d_fnum_edit_proc,        279, 220, 40,  8,   CTX, CBD, 0,   0,      4,          0,  "sp10\0",                     NULL,     NULL },
/*41*/{ d_text_proc,             167, 229, 112, 8,   CTX, CFG, 0,   0,      0,          0,  "Buy Profit:",                NULL,     NULL },
/*42*/{ d_fnum_edit_proc,        279, 229, 40,  8,   CTX, CBD, 0,   0,      4,          0,  "bp10\0",                     NULL,     NULL },
/*45*/{ d_button_proc,           405, 410, 130, 25,  CTX, CFG, 0,   D_EXIT, 0,          0,  "Return",                     NULL,     NULL },
standarnd_dialog_chunks
};

char *shop_lister( int index, int *list_size )
{
    static char tmp[42];
    MOBILE *mob;

    if( index < 0 ){
      *list_size = world.zone[cur_zone].num_shops;
      return "";
      }

    tmp[41] = '\0';
    mob = find_mobile_vnum_zone( &world.zone[cur_zone], world.zone[cur_zone].shop[index].mobile );
    if( mob ){
      strncpy( &tmp[1], mob->short_desc, 40 );
      }
    else{
      strncpy( &tmp[1], "Unknown mobile", 40 );
      }
    if( index == cur_shop ){
      tmp[0] = '';
      }
    else{
      tmp[0] = ' ';
      }

    return tmp;
}

int shop_list_proc( int msg, DIALOG *d, int c )
{
    int ret, mmb;

    mmb = mouse_b;

    ret = d_list_proc( msg, d, c );

    if( msg == MSG_CLICK ){
      if( mmb & 2 ){
        if( world.zone[cur_zone].num_shops < 1 ){
          menu_shop_list[1].flags |= D_DISABLED;
          menu_shop_list[2].flags |= D_DISABLED;
          menu_shop_list[3].flags |= D_DISABLED;
          }
        else{
          menu_shop_list[1].flags &= ~D_DISABLED;
          menu_shop_list[2].flags &= ~D_DISABLED;
          menu_shop_list[3].flags &= ~D_DISABLED;
          }
        switch( do_menu( menu_shop_list, mouse_x, mouse_y ) ){
          case 0:
               cur_shop = add_shop( &world.zone[cur_zone] );
               mob_ed();
               world.zone[cur_zone].shop[cur_shop].mobile = cur_mobile;
               d->d1 = cur_shop;
               return D_REDRAW;
               break;

          case 1:
               cur_shop = d->d1;
               return D_REDRAW;
               break;

          case 2:
               cur_mobile = ifind_mobile_vnum_zone( &world.zone[cur_zone], world.zone[cur_zone].shop[d->d1].mobile );
               mob_ed();
               world.zone[cur_zone].shop[d->d1].mobile = cur_mobile;
               return D_REDRAW;
               break;

          case 3:
               del_shop( &world.zone[cur_zone], d->d1 );
               if( d->d1 >= world.zone[cur_zone].num_shops ){
                 d->d1 = world.zone[cur_zone].num_shops-1;
                 }
               return D_REDRAW;
               break;
          }
        }
      }
    else if( msg == MSG_DCLICK ){
      if( world.zone[cur_zone].num_shops > 0 ){
        cur_shop = d->d1;
        }
      return D_REDRAW;
      }

    return ret;
}

char *item_lister( int index, int *list_size )
{
    OBJECT *item;

    if( index < 0 ){
      if( world.zone[cur_zone].num_shops < 1 ){
        *list_size = 0;
        }
      else{
        *list_size = world.zone[cur_zone].shop[cur_shop].num_items;
        }
      return "";
      }

    item = find_object_vnum_zone( &world.zone[cur_zone], world.zone[cur_zone].shop[cur_shop].item[index] );
    if( item ){
      return item->short_desc;
      }
    else{
      return "Unknown item";
      }

    return NULL;
}

int item_list_proc( int msg, DIALOG *d, int c )
{
    int ret, mmb;

    mmb = mouse_b;

    ret = d_list_proc( msg, d, c );

    if( world.zone[cur_zone].num_shops < 1 || cur_shop < 0 ){
      if( !(d->flags & D_DISABLED) ){
        d->flags |= D_DISABLED;
        d->proc( MSG_DRAW, d, c );
        }
      }
    else{
      if( (d->flags & D_DISABLED) ){
        d->flags &= ~D_DISABLED;
        d->proc( MSG_DRAW, d, c );
        }
  
      if( msg == MSG_CLICK ){
        if( mmb & 2 ){
          if( world.zone[cur_zone].shop[cur_shop].num_items < 1 ){
            menu_item_list[1].flags |= D_DISABLED;
            menu_item_list[2].flags |= D_DISABLED;
            }
          else{
            menu_item_list[1].flags &= ~D_DISABLED;
            menu_item_list[2].flags &= ~D_DISABLED;
            }
          switch( do_menu( menu_item_list, mouse_x, mouse_y ) ){
            case 0:
                 d->d1 = add_shop_item( &world.zone[cur_zone].shop[cur_shop] );
                 obj_ed();
                 world.zone[cur_zone].shop[cur_shop].item[d->d1] = cur_object;
                 return D_REDRAW;
                 break;
  
            case 1:
                 cur_object = ifind_object_vnum_zone( &world.zone[cur_zone], world.zone[cur_zone].shop[cur_shop].item[d->d1] );
                 obj_ed();
                 world.zone[cur_zone].shop[cur_shop].item[d->d1] = cur_object;
                 return D_REDRAW;
                 break;
  
            case 2:
                 del_shop_item( &world.zone[cur_zone].shop[cur_shop], d->d1 );
                 if( d->d1 >= world.zone[cur_zone].shop[cur_shop].num_items ){
                   d->d1 = world.zone[cur_zone].shop[cur_shop].num_items-1;
                   }
                 d->proc( MSG_DRAW, d, c );
                 break;
            }
          }
        }
      }

    return ret;
}

char *room_lister( int index, int *list_size )
{
    ROOM *room;

    if( index < 0 ){
      if( world.zone[cur_zone].num_shops < 1 ){
        *list_size = 0;
        }
      else{
        *list_size = world.zone[cur_zone].shop[cur_shop].num_rooms;
        }
      return "";
      }

    room = find_room_vnum_zone( &world.zone[cur_zone], world.zone[cur_zone].shop[cur_shop].room[index] );
    if( room ){
      return room->title;
      }
    else{
      return "Unknown room";
      }

    return NULL;
}

int room_list_proc( int msg, DIALOG *d, int c )
{
    int ret, mmb;

    mmb = mouse_b;

    ret = d_list_proc( msg, d, c );

    if( world.zone[cur_zone].num_shops < 1 || cur_shop < 0 ){
      if( !(d->flags & D_DISABLED) ){
        d->flags |= D_DISABLED;
        d->proc( MSG_DRAW, d, c );
        }
      }
    else{
      if( (d->flags & D_DISABLED) ){
        d->flags &= ~D_DISABLED;
        d->proc( MSG_DRAW, d, c );
        }
  
      if( msg == MSG_CLICK ){
        if( mmb & 2 ){
          if( world.zone[cur_zone].shop[cur_shop].num_rooms < 1 ){
            menu_room_list[1].flags |= D_DISABLED;
            }
          else{
            menu_room_list[1].flags &= ~D_DISABLED;
            }
          switch( do_menu( menu_room_list, mouse_x, mouse_y ) ){
            case 0:
                 d->d1 = add_shop_room( &world.zone[cur_zone].shop[cur_shop] );
                 world.zone[cur_zone].shop[cur_shop].room[d->d1] = -1;
                 return D_REDRAW;
                 break;
  
            case 1:
                 del_shop_room( &world.zone[cur_zone].shop[cur_shop], d->d1 );
                 if( d->d1 >= world.zone[cur_zone].shop[cur_shop].num_rooms ){
                   d->d1 = world.zone[cur_zone].shop[cur_shop].num_rooms-1;
                   }
                 d->proc( MSG_DRAW, d, c );
                 break;
            }
          }
        else{
          cur_room = ifind_room_vnum_zone( &world.zone[cur_zone], world.zone[cur_zone].shop[cur_shop].room[d->d1] );
          shp_ed_dlg[8].proc( MSG_DRAW, &shp_ed_dlg[8], 0 );
          }
        }
      }

    return ret;
}

int d_shop_map_proc( int msg, DIALOG *d, int c )
{
    int ret = D_O_K, selmade=0;
    int k, x, y;
    static int ox, oy;
    static BITMAP *bf;

    if( msg == MSG_START ){
      ox=0;
      oy=0;
      bf = create_bitmap( d->w-2, d->h-2 );
      }
    else if( msg == MSG_DRAW ){
      clear_to_color( bf, d->bg );
      draw_map( &world, bf, ox, oy, cur_layer, DMODE_SINGLE, (void *)(cur_zone), (void *)(cur_room), mapopt|DRAW_1ZONE );
      scare_mouse();
      rect( screen, d->x, d->y, d->x+d->w, d->y+d->h, d->fg );
      blit( bf, screen, 0, 0, d->x+1, d->y+1, bf->w, bf->h );
      unscare_mouse();
      }

    if( world.zone[cur_zone].num_shops < 1 || cur_shop < 0 ){
      if( !(d->flags & D_DISABLED) ){
        d->flags |= D_DISABLED;
        d->proc( MSG_DRAW, d, c );
        }
      }
    else{
      if( (d->flags & D_DISABLED) ){
        d->flags &= ~D_DISABLED;
        d->proc( MSG_DRAW, d, c );
        }
  
      switch( msg ){
        case MSG_WANTFOCUS:
             return D_WANTFOCUS;
  
        case MSG_DRAW:
             clear_to_color( bf, d->bg );
             draw_map( &world, bf, ox, oy, cur_layer, DMODE_SINGLE, (void *)(cur_zone), (void *)(cur_room), mapopt|DRAW_1ZONE );
             scare_mouse();
             if( (d->flags&D_GOTFOCUS) ){
               dotted_rect( screen, d->x, d->y, d->x+d->w, d->y+d->h, d->fg, d->bg );
               }
             else{
               rect( screen, d->x, d->y, d->x+d->w, d->y+d->h, d->fg );
               }
             blit( bf, screen, 0, 0, d->x+1, d->y+1, bf->w, bf->h );
             unscare_mouse();
             break;

        case MSG_CHAR:
             if( c>>8 == KEY_PGUP ){
               cur_layer++;
               d->proc( MSG_DRAW, d, c );
               return D_USED_CHAR;
               }
             if( c>>8 == KEY_PGDN ){
               cur_layer--;
               d->proc( MSG_DRAW, d, c );
               return D_USED_CHAR;
               }
             break;

        case MSG_CLICK:
             x = mouse_x-d->x-1;
             y = mouse_y-d->y-1;
             x = x - bf->w/2 - ox;
             y = y - bf->h/2 - oy;
             for( k = 0; k < world.zone[cur_zone].num_rooms; k++ ){
                if( x >= world.zone[cur_zone].room[k].x*GS-RR &&
                    x <= world.zone[cur_zone].room[k].x*GS+RR &&
                    y >= world.zone[cur_zone].room[k].y*GS-RR &&
                    y <= world.zone[cur_zone].room[k].y*GS+RR ){
                  selmade = -1;
                  cur_room = k;
                  world.zone[cur_zone].shop[cur_shop].room[shp_ed_dlg[7].d1] = world.zone[cur_zone].room[k].vnum;

                  shp_ed_dlg[7].proc( MSG_DRAW, &shp_ed_dlg[7], 0 );
                  d->proc( MSG_DRAW, d, c );
                  while( mouse_b );
  
                  break;
                  }
                }
             if( !selmade ){
/* Code to move around the map with mouse-draggin' */
               if( mouse_b & 1 ){
                 get_mouse_mickeys( &x, &y );
                 scare_mouse();
                 while( mouse_b & 1 ){
                   get_mouse_mickeys( &x, &y );
                   if( x != 0 || y != 0 ){
                     ox += x;
                     oy += y;
                     d->proc( MSG_DRAW, d, c );
                     }
                   }
                 unscare_mouse();
                 }
               }
             break;
        }
      }

    return ret;
}

int shp_ed_refresher( int msg, DIALOG *d, int c )
{
    char buf[100];

    d = NULL;
    c = 0;

greyer_thing_code

    if( msg == MSG_DRAW ){
      if( world.zone[cur_zone].num_shops == 0 ){
        shp_ed_dlg[12].flags  |= D_DISABLED;
        shp_ed_dlg[14].flags  |= D_DISABLED;
        shp_ed_dlg[16].flags  |= D_DISABLED;
        shp_ed_dlg[18].flags  |= D_DISABLED;
        shp_ed_dlg[22].flags  |= D_DISABLED;
        shp_ed_dlg[24].flags  |= D_DISABLED;
        shp_ed_dlg[26].flags  |= D_DISABLED;
        shp_ed_dlg[28].flags  |= D_DISABLED;
        shp_ed_dlg[30].flags  |= D_DISABLED;
        shp_ed_dlg[32].flags  |= D_DISABLED;
        shp_ed_dlg[34].flags  |= D_DISABLED;
        shp_ed_dlg[37].flags  |= D_DISABLED;
        shp_ed_dlg[38].flags  |= D_DISABLED;
        shp_ed_dlg[40].flags  |= D_DISABLED;
        shp_ed_dlg[42].flags  |= D_DISABLED;

        strcpy( shp_ed_dlg[12].dp, "   " );
        strcpy( shp_ed_dlg[14].dp, "   " );
        strcpy( shp_ed_dlg[16].dp, "   " );
        strcpy( shp_ed_dlg[18].dp, "   " );
        shp_ed_dlg[22].dp = blankstr;
        shp_ed_dlg[24].dp = blankstr;
        shp_ed_dlg[26].dp = blankstr;
        shp_ed_dlg[28].dp = blankstr;
        shp_ed_dlg[30].dp = blankstr;
        shp_ed_dlg[32].dp = blankstr;
        shp_ed_dlg[34].dp = blankstr;
        shp_ed_dlg[37].dp = blankstr;
        shp_ed_dlg[38].dp = blankstr;
        strcpy( shp_ed_dlg[40].dp, "    " );
        strcpy( shp_ed_dlg[42].dp, "    " );
        return D_O_K;
        }
      else{
        if( (shp_ed_dlg[5].flags & D_DISABLED) ){
          cur_shop = 0;
          shp_ed_dlg[12].flags  &= ~D_DISABLED;
          shp_ed_dlg[14].flags  &= ~D_DISABLED;
          shp_ed_dlg[16].flags  &= ~D_DISABLED;
          shp_ed_dlg[18].flags  &= ~D_DISABLED;
          shp_ed_dlg[22].flags  &= ~D_DISABLED;
          shp_ed_dlg[24].flags  &= ~D_DISABLED;
          shp_ed_dlg[26].flags  &= ~D_DISABLED;
          shp_ed_dlg[28].flags  &= ~D_DISABLED;
          shp_ed_dlg[30].flags  &= ~D_DISABLED;
          shp_ed_dlg[32].flags  &= ~D_DISABLED;
          shp_ed_dlg[34].flags  &= ~D_DISABLED;
          if( world.zone[cur_zone].shop[cur_shop].num_bspecs > 0 && shp_ed_dlg[36].d1 >= 0 && shp_ed_dlg[36].d1 < world.zone[cur_zone].shop[cur_shop].num_bspecs ){
            shp_ed_dlg[37].flags  &= ~D_DISABLED;
            shp_ed_dlg[38].flags  &= ~D_DISABLED;
            }
          shp_ed_dlg[40].flags  &= ~D_DISABLED;
          shp_ed_dlg[42].flags  &= ~D_DISABLED;
          }
        }
      sprintf( shp_ed_dlg[12].dp, "%d", world.zone[cur_zone].shop[cur_shop].topen[0] );
      sprintf( shp_ed_dlg[14].dp, "%d", world.zone[cur_zone].shop[cur_shop].tclose[0] );
      sprintf( shp_ed_dlg[16].dp, "%d", world.zone[cur_zone].shop[cur_shop].topen[1] );
      sprintf( shp_ed_dlg[18].dp, "%d", world.zone[cur_zone].shop[cur_shop].tclose[1] );
      shp_ed_dlg[12].dp2 = &world.zone[cur_zone].shop[cur_shop].topen[0];
      shp_ed_dlg[14].dp2 = &world.zone[cur_zone].shop[cur_shop].tclose[0];
      shp_ed_dlg[16].dp2 = &world.zone[cur_zone].shop[cur_shop].topen[1];
      shp_ed_dlg[18].dp2 = &world.zone[cur_zone].shop[cur_shop].tclose[1];
      shp_ed_dlg[22].dp = world.zone[cur_zone].shop[cur_shop].buy_item_ne;
      shp_ed_dlg[24].dp = world.zone[cur_zone].shop[cur_shop].sell_item_ne;
      shp_ed_dlg[26].dp = world.zone[cur_zone].shop[cur_shop].refuse_offer;
      shp_ed_dlg[28].dp = world.zone[cur_zone].shop[cur_shop].shop_afford;
      shp_ed_dlg[30].dp = world.zone[cur_zone].shop[cur_shop].play_afford;
      shp_ed_dlg[32].dp = world.zone[cur_zone].shop[cur_shop].buy_success;
      shp_ed_dlg[34].dp = world.zone[cur_zone].shop[cur_shop].sell_success;
      if( world.zone[cur_zone].shop[cur_shop].num_bspecs > 0 && shp_ed_dlg[36].d1 >= 0 && shp_ed_dlg[36].d1 < world.zone[cur_zone].shop[cur_shop].num_bspecs ){
        shp_ed_dlg[37].dp3 = &world.zone[cur_zone].shop[cur_shop].bspec[shp_ed_dlg[36].d1].type;
        shp_ed_dlg[37].dp = object_type_list_menu[world.zone[cur_zone].shop[cur_shop].bspec[shp_ed_dlg[36].d1].type].text;
        shp_ed_dlg[38].dp = world.zone[cur_zone].shop[cur_shop].bspec[shp_ed_dlg[36].d1].namelist;
        }
      sprintf( buf, "%1.2f", world.zone[cur_zone].shop[cur_shop].prof_sell );
      strncpy( shp_ed_dlg[40].dp, buf, 4 );
      sprintf( buf, "%1.2f", world.zone[cur_zone].shop[cur_shop].prof_buy );
      strncpy( shp_ed_dlg[42].dp, buf, 4 );
      shp_ed_dlg[40].dp2 = &world.zone[cur_zone].shop[cur_shop].prof_sell;
      shp_ed_dlg[42].dp2 = &world.zone[cur_zone].shop[cur_shop].prof_buy;
      }

    return D_O_K;
}

int shp_ed()
{
    int ocur_room;

    if( world.zone[cur_zone].num_shops < 1 ||
        cur_shop >= world.zone[cur_zone].num_shops ){
      cur_shop = -1;
      }

    ocur_room = cur_room;
    do_dialog( shp_ed_dlg, 0 );
    cur_room = ocur_room;

    return D_REDRAW;
}

int shp_ed_init()
{
    set_colors( shp_ed_dlg );
    centre_dialog( shp_ed_dlg );

    return 0;
}

char *shop_bv_lister( int index, int *list_size )
{
    static char tmp[42];

    if( index < 0 ){
      *list_size = 2;
      return "";
      }

    tmp[0] = ' ';
    tmp[41] = '\0';
    strncpy( &tmp[1], shop_bv_list[index], 40 );
    if( world.zone[cur_zone].num_shops < 1 || cur_shop < 0 ){
      return tmp;
      }
    else{
      if( ((1<<index)&world.zone[cur_zone].shop[cur_shop].shop_bv) ){
        tmp[0] = '';
        }
      return tmp;
      }
}

int shop_bv_list_proc( int msg, DIALOG *d, int c )
{
    int ret = d_list_proc( msg, d, c );

    if( world.zone[cur_zone].num_shops < 1 || cur_shop < 0 ){
      if( !(d->flags & D_DISABLED) ){
        d->flags |= D_DISABLED;
        d->proc( MSG_DRAW, d, c );
        }
      }
    else{
      if( (d->flags & D_DISABLED) ){
        d->flags &= ~D_DISABLED;
        d->proc( MSG_DRAW, d, c );
        }
  
      if( msg == MSG_DCLICK ){
        if( ((1<<d->d1)&world.zone[cur_zone].shop[cur_shop].shop_bv) ){
          world.zone[cur_zone].shop[cur_shop].shop_bv = world.zone[cur_zone].shop[cur_shop].shop_bv&(~(1<<d->d1));
          }
        else{
          world.zone[cur_zone].shop[cur_shop].shop_bv = world.zone[cur_zone].shop[cur_shop].shop_bv|(1<<d->d1);
          }
        d->proc( MSG_DRAW, d, 0 );
        }
      }

    return ret;
}

char *withwho_bv_lister( int index, int *list_size )
{
    static char tmp[42];

    if( index < 0 ){
      *list_size = 7;
      return "";
      }

    tmp[0] = ' ';
    tmp[41] = '\0';
    strncpy( &tmp[1], shop_withwho_bv_list[index], 40 );
    if( world.zone[cur_zone].num_shops < 1 || cur_shop < 0 ){
      return tmp;
      }
    else{
      if( ((1<<index)&world.zone[cur_zone].shop[cur_shop].withwho_bv) ){
        tmp[0] = '';
        }
      return tmp;
      }
}

int withwho_bv_list_proc( int msg, DIALOG *d, int c )
{
    int ret = d_list_proc( msg, d, c );

    if( world.zone[cur_zone].num_shops < 1 || cur_shop < 0 ){
      if( !(d->flags & D_DISABLED) ){
        d->flags |= D_DISABLED;
        d->proc( MSG_DRAW, d, c );
        }
      }
    else{
      if( (d->flags & D_DISABLED) ){
        d->flags &= ~D_DISABLED;
        d->proc( MSG_DRAW, d, c );
        }
  
      if( msg == MSG_DCLICK ){
        if( ((1<<d->d1)&world.zone[cur_zone].shop[cur_shop].withwho_bv) ){
          world.zone[cur_zone].shop[cur_shop].withwho_bv = world.zone[cur_zone].shop[cur_shop].withwho_bv&(~(1<<d->d1));
          }
        else{
          world.zone[cur_zone].shop[cur_shop].withwho_bv = world.zone[cur_zone].shop[cur_shop].withwho_bv|(1<<d->d1);
          }
        d->proc( MSG_DRAW, d, 0 );
        }
      }

    return ret;
}

char *bspec_lister( int index, int *list_size )
{
    static char tmp[82];

    if( index < 0 ){
      if( world.zone[cur_zone].num_shops < 1 || cur_shop < 0 )
        *list_size = 0;
      else
        *list_size = world.zone[cur_zone].shop[cur_shop].num_bspecs;
      return "";
      }

    sprintf( tmp, "%-15s - %s", object_type_list[world.zone[cur_zone].shop[cur_shop].bspec[index].type], world.zone[cur_zone].shop[cur_shop].bspec[index].namelist );

    return tmp;
}

int bspec_list_proc( int msg, DIALOG *d, int c )
{
    int ret, mmb;

    mmb = mouse_b;

    ret = d_list_proc( msg, d, c );

    if( world.zone[cur_zone].num_shops < 1 || cur_shop < 0 ){
      if( !(d->flags & D_DISABLED) ){
        d->flags |= D_DISABLED;
        d->proc( MSG_DRAW, d, c );
        }
      }
    else{
      if( (d->flags & D_DISABLED) ){
        d->flags &= ~D_DISABLED;
        d->proc( MSG_DRAW, d, c );
        }
  
      if( msg == MSG_CLICK ){
        if( mmb & 2 ){
          if( world.zone[cur_zone].shop[cur_shop].num_bspecs < 1 ){
            menu_bspec_list[1].flags |= D_DISABLED;
            }
          else{
            menu_bspec_list[1].flags &= ~D_DISABLED;
            }
          switch( do_menu( menu_bspec_list, mouse_x, mouse_y ) ){
            case 0:
                 d->d1 = add_shop_bspec( &world.zone[cur_zone].shop[cur_shop] );
                 d->proc( MSG_DRAW, d, c );
                 break;
  
            case 1:
                 del_shop_bspec( &world.zone[cur_zone].shop[cur_shop], d->d1 );
                 if( d->d1 >= world.zone[cur_zone].shop[cur_shop].num_bspecs ){
                   d->d1 = world.zone[cur_zone].shop[cur_shop].num_bspecs-1;
                   }
                 d->proc( MSG_DRAW, d, c );
                 break;
            }
          }
  /* Update the editor thingies... */
        if( world.zone[cur_zone].shop[cur_shop].num_bspecs > 0 && shp_ed_dlg[36].d1 >= 0 && shp_ed_dlg[36].d1 < world.zone[cur_zone].shop[cur_shop].num_bspecs ){
          shp_ed_dlg[37].dp3 = &world.zone[cur_zone].shop[cur_shop].bspec[shp_ed_dlg[36].d1].type;
          shp_ed_dlg[37].dp = object_type_list_menu[world.zone[cur_zone].shop[cur_shop].bspec[shp_ed_dlg[36].d1].type].text;
          shp_ed_dlg[37].flags &= ~D_DISABLED;
          shp_ed_dlg[37].proc( MSG_DRAW, &shp_ed_dlg[37], 0 );
          shp_ed_dlg[38].dp = world.zone[cur_zone].shop[cur_shop].bspec[shp_ed_dlg[36].d1].namelist;
          shp_ed_dlg[38].flags &= ~D_DISABLED;
          shp_ed_dlg[38].proc( MSG_DRAW, &shp_ed_dlg[38], 0 );
          }
        else{
          shp_ed_dlg[38].dp = blankstr;
          shp_ed_dlg[38].flags |= D_DISABLED;
          shp_ed_dlg[38].proc( MSG_DRAW, &shp_ed_dlg[38], 0 );
          shp_ed_dlg[37].dp = blankstr;
          shp_ed_dlg[37].flags |= D_DISABLED;
          shp_ed_dlg[37].proc( MSG_DRAW, &shp_ed_dlg[37], 0 );
          }
        }
      }

    return ret;
}

int d_aupd_edit_proc( int msg, DIALOG *d, int c )
{
    int ret = d_edit_proc( msg, d, c );

    if( ret == D_USED_CHAR ){
      shp_ed_dlg[36].proc( MSG_DRAW, &shp_ed_dlg[36], c );
      }

    return ret;
}

char *temper_lister( int index, int *list_size )
{
    static char tmp[42];

    if( index < 0 ){
      *list_size = 3;
      return "";
      }

    tmp[0] = ' ';
    tmp[41] = '\0';
    strncpy( &tmp[1], shop_temper_list[index], 40 );
    if( world.zone[cur_zone].num_shops < 1 || cur_shop < 0 ){
      return tmp;
      }
    else{
      if( index == world.zone[cur_zone].shop[cur_shop].temper ){
        tmp[0] = '';
        }
      return tmp;
      }
}

int temper_list_proc( int msg, DIALOG *d, int c )
{
    int ret = d_list_proc( msg, d, c );

    if( world.zone[cur_zone].num_shops < 1 || cur_shop < 0 ){
      if( !(d->flags & D_DISABLED) ){
        d->flags |= D_DISABLED;
        d->proc( MSG_DRAW, d, c );
        }
      }
    else{
      if( (d->flags & D_DISABLED) ){
        d->flags &= ~D_DISABLED;
        d->proc( MSG_DRAW, d, c );
        }
  
      if( msg == MSG_DCLICK ){
        world.zone[cur_zone].shop[cur_shop].temper = d->d1;
        d->proc( MSG_DRAW, d, 0 );
        }
      }

    return ret;
}

